// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.controllers' is found in controllers.js
angular.module('starter', ['ionic', 'starter.controllers','google-maps','geolocation'])

/*
.run(['$templateCache', function ( $templateCache ) {
    $templateCache.removeAll(); }])
*/

.run(function($ionicPlatform) {
  $ionicPlatform.ready(function() {
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if(window.cordova && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
    }
    if(window.StatusBar) {
      // org.apache.cordova.statusbar required
      StatusBar.styleDefault();
    }
  });
})

.config(function($stateProvider, $urlRouterProvider) {
  $stateProvider
    .state('app', {
      url: "/app",
      abstract: true,
      templateUrl: "templates/menu.html",
      controller: 'AppCtrl'
    })
    
    .state('app.accueil', {
      url: "/accueil",
      views: {
        'menuContent' :{
          templateUrl: "templates/accueil.html",
          controller:'AppAccueil'
        }
      }
    })

    .state('app.inter', {
      url: "/inter",
      views: {
        'menuContent' :{
          templateUrl: "templates/inter.html",
          controller:'interCtrl'
        }
      }
    })
    
    .state('app.fiches', {
      url: "/fiches/:index",
      views: {
        'menuContent' :{
          templateUrl: "templates/fiches.html",
          controller:'visualisation_showFiche'
        }
      }
    })
    
    
    .state('app.recherchearret', {
      url: "/recherchearret",
      views: {
        'menuContent' :{
          templateUrl: "templates/recherchearret.html",
          controller:'visualisation_recherchearret'
        }
      }
    })
    
    .state('app.trajet', {
      url: "/trajet",
      views: {
        'menuContent' :{
          templateUrl: "templates/trajet.html",
          controller:'visualisation_trajet'
        }
      }
    })
    
    .state('app.findDepart', {
      url: "/findDepart/:mode",
      views: {
        'menuContent' :{
          templateUrl: "templates/findDepart.html",
          controller:'TestSearch'
        }
      }
    })

    .state('app.page', {
      url: "/page",
      views: {
        'menuContent' :{
          templateUrl: "templates/page.html",
          controller:'PageCtrl'
        }
      }
    })

    .state('app.search', {
      url: "/search",
      
      views: {
        'menuContent' :{
          templateUrl: "templates/search.html",
          controller:'TestSearch'
        }
      }
    })

    .state('app.browse', {
      url: "/browse",
      views: {
        'menuContent' :{
          templateUrl: "templates/browse.html"
        }
      }
    })
   
    .state('app.carto', {
      url: "/carto",
      views: {
        'menuContent' :{
          templateUrl: "templates/carto.html",
          controller:'Cartographie'
        }
      }
    })
    
    .state('app.alertes', {
      url: "/alertes",
      views: {
        'menuContent' :{
          templateUrl: "templates/alertes.html",
          controller:'Alertes'
        }
      }
    })
    
     .state('app.contacts', {
      url: "/contacts",
      views: {
        'menuContent' :{
          templateUrl: "templates/contacts.html",
          controller:'Contact'
        }
      }
    })
    
    .state('app.profil', {
      url: "/profil",
      views: {
        'menuContent' :{
          templateUrl: "templates/profil.html",
          controller:'Profil'
        }
      }
    })
    
    .state('app.horaires', {
      url: "/horaires",
      views: {
        'menuContent' :{
          templateUrl: "templates/horaires.html",
          controller:'horaires'
        }
      }
    })
    
    .state('app.playlists', {
      url: "/playlists",
      views: {
        'menuContent' :{
          templateUrl: "templates/playlists.html",
          controller: 'PlaylistsCtrl'
        }
      }
    })

    .state('app.single', {
      url: "/playlists/:playlistId",
      views: {
        'menuContent' :{
          templateUrl: "templates/playlist.html",
          controller: 'PlaylistCtrl'
        }
      }
    });
  // if none of the above states are matched, use this as the fallback
  $urlRouterProvider.otherwise('/app/accueil');
});

