//angular.module('starter.controllers', ['ionic','LocalStorageModule','angucomplete','AngularGM','ngSanitize','leaflet-directive'])
angular.module('starter.controllers', ['ionic','LocalStorageModule','angucomplete','ngSanitize','leaflet-directive'])

.filter('toHHMMSS', function toHHMMSS(){
    return function(value){
        var sec_num = parseInt(value, 10);
        var hours   = Math.floor(sec_num / 3600);
        var minutes = Math.floor((sec_num - (hours * 3600)) / 60);
        var seconds = sec_num - (hours * 3600) - (minutes * 60);
        if (hours   < 10) {hours   = "0"+hours;}
        if (minutes < 10) {minutes = "0"+minutes;}
        if (seconds < 10) {seconds = "0"+seconds;}
        var time    = hours+':'+minutes+':'+seconds;
        return "env. "+minutes+" mn";
    }
})

.filter('toHHMMSSsimple', function toHHMMSSsimple(){
    return function(value){
        var sec_num = parseInt(value, 10);
        var hours   = Math.floor(sec_num / 3600);
        var minutes = Math.floor((sec_num - (hours * 3600)) / 60);
        var seconds = sec_num - (hours * 3600) - (minutes * 60);
        if (hours   < 10) {hours   = "0"+hours;}
       // if (minutes < 10) {minutes = "0"+minutes;}
        if (seconds < 10) {seconds = "0"+seconds;}
        var time    = hours+':'+minutes+':'+seconds;
        return minutes;
    }
})

.filter('dateJour', function dateJour(){
    return function(value){
    	value=value.split("-");
    	if(value[0]<10){
	    	value[0]="0"+value[0];
    	}
        return value[0];
    }
})

.filter('dateMois', function dateMois(){
    return function(value){
    	value=value.split("-");
    	//alert(value[1]);
    	if(value[1]<10){
	    	value[1]="0"+value[1];
    	}
        return value[1];
    }
})


.filter('co2', function co2(){
    return function(value){
    	value=value.split(".");
        return value[0];
    }
})


.filter('formatmetre', function formatmetre(){
    return function(value){
        return Math.round(value*1000);
    }
})


.filter('toKM', function toKM(){
    return function(value){
        return Math.round(value/1000);
    }
})

.filter('simplify', function simplify(){
    return function(value){
        return value.substring(0, value.length - 3);
    }
})

.filter('addZero', function addZero(){
    return function(value){
        if(parseInt(value)<10){
        	return "0"+value;
        }else{
	        return value;
        }
    }
})

.filter('meters', function meters(){
    return function(value){
        
	        return parseInt(value*1000);
        
    }
})

.filter('formatHeures', function fh(){
    return function(value){
    	if(value.indexOf("-") > -1){
	    	return "<span style='color:red'>"+value.replace('-','')+"</span>";
    	}      
	       return value;       
    }
})



.factory('Screen',['$rootScope','$window',function($rootScope,$window){
		return{
			GetHeight:function(){
				return $window.innerHeight;
			},
			GetWidth:function(){
				return $window.innerWidth;
			}
		}
}])

.factory('Trajet', ['$rootScope', function($rootScope) {
    return {
        trajet: {},
        GetTrajet: function () {
            return this.trajet;
        },
        SetTrajet:function(value){
	        this.trajet=value;
	        return this.trajet;
        }
    }
}])


.factory('Mode', ['$rootScope', function($rootScope) {
    return {
        Mode: {type:"depart"},
        GetMode: function () {
            return this.Mode.type;
        },
        SetMode:function(value){
	        this.Mode.type=value;
	        return this.Mode.type;
        },
        SetModeDepart:function(){
	        this.Mode.type="depart";
	        return this.Mode.type;
        },
        SetModeDepart:function(){
	        this.Mode.type="arrivee";
	        return this.Mode.type;
        }
    }
}])



.factory('Jours',function(){
	return{
		jours:{},
		GetJours:function(daysToAdd){			
			  	startDate=new Date();
			  	aryDates=[];
			  	
			  	 var month = new Array();
					    month[0] = "janvier";
					    month[1] = "février";
					    month[2] = "mars";
					    month[3] = "avril";
					    month[4] = "mai";
					    month[5] = "juin";
					    month[6] = "juillet";
					    month[7] = "août";
					    month[8] = "septembre";
					    month[9] = "octobre";
					    month[10] = "novembre";
					    month[11] = "décembre";
					    
				var weekdays = new Array(7);
					    weekdays[0] = "Dimanche";
					    weekdays[1] = "Lundi";
					    weekdays[2] = "Mardi";
					    weekdays[3] = "Mercredi";
					    weekdays[4] = "Jeudi";
					    weekdays[5] = "Vendredi";
					    weekdays[6] = "Samedi";
				    
		  		for (var i = 0; i <= daysToAdd; i++) {
				        var currentDate = new Date();
				        currentDate.setDate(startDate.getDate() + i);
				        if(i==0){
					        date_format="Aujourd'hui";
				        }else if(i==1){
					        date_format="Demain";
				        }else{
					        date_format=weekdays[currentDate.getDay()] + " " + currentDate.getDate()+" "+ month[currentDate.getMonth()] + " " +currentDate.getFullYear()
				        }
				        aryDates.push({label:date_format,data:currentDate.getDate()+"-"+(currentDate.getMonth()+1)+"-"+currentDate.getFullYear()});
				    }
				return aryDates;
		}
	}
})

.factory('Coordinates', function () {
    return {
        coordinates: {},
        AllCoordinates:{},
        GetAll: function (coords) {
            return this.coordinates;
        },
        GetById: function (id) {
            //iterate MoviesList and return proper movie
        },
        SetDepart:function(dep){
	        this.coordinates.depart.adresse=dep;
        },
        SetArrivee:function(arr){
	        this.coordinates.arrivee.adresse=arr;
        }
    }
})


.factory('ficheHoraires', ['localStorageService','$rootScope', function (localStorageService,$rootScope) {
    return {
        fiche: {"remote":{arret:"",ligne:"",direction:""},"simple":{arret:"",ligne:"",direction:""}},
        GetFiche: function () {
            return this.fiche;
        },
        GetLastFiche: function () {
            if(localStorageService.get('fiche')!=null){
	        	this.parcours=angular.fromJson(localStorageService.get('fiche'));
        	}
            return this.fiche;
        },
        Save:function(){
	        localStorageService.set('fiche',angular.toJson(this.fiche));
        },
        UpdateFiche:function(){
	       $rootScope.$broadcast('UpdateFiche');
        },
        SetRemote:function(a,l,h){
	        this.fiche.remote={arret:a,ligne:l,direction:h};
	        this.Save();
	        return this.fiche.remote;
        },
        SetSimple:function(a,l,h){
	        this.fiche.simple={arret:a,ligne:l,direction:h};
	        this.Save();
	        return this.fiche.simple;
        }

    }
}])



.factory('Itineraires', ['localStorageService','$rootScope', function (localStorageService,$rootScope) {
    return {
        parcours: {depart:{adresse:"",stops:[],select:""},arrivee:{adresse:"",stops:[],select:""},jour:"",heure:"","trajets":{}},
        GetParcours: function () {
            return this.parcours;
        },
        GetLastParcours: function () {
            if(localStorageService.get('parcours')!=null){
	        	this.parcours=angular.fromJson(localStorageService.get('parcours'));
        	}
            return this.parcours;
        },
        Save:function(){
	        localStorageService.set('parcours',angular.toJson(this.parcours));
        },
        UpdateItineraire:function(){
	       $rootScope.$broadcast('UpdateItineraire');
        },
        GetAdresse: function (step) {
            return this.parcours[step]["adresse"];
        },
        SetAdresse: function (step,value) {
            this.parcours[step]["adresse"]=value;
        },
        GetTrajets: function (step) {
            return this.parcours["trajets"];
        },
        SetTrajets: function (value) {
            this.parcours["trajets"]=value;
            return this.parcours["trajets"];
        },
        GetStops: function (step) {
			return this.parcours[step]["stops"];
        },
        GetStopsById: function (step,id) {
			return this.parcours[step]["stops"][id]["value"];
        },
        SetStops:function(step,arr){
	        this.parcours[step]["stops"]=arr;
        },
        GetSelect: function (step) {
			return this.parcours[step]["select"];
        },
        SetSelect:function(step,value){
	        this.parcours[step]["select"]=value;
	        $rootScope.$broadcast('UpdateItineraire');
        },
        GetJour: function () {
            return this.parcours.jour;
        },
        SetJour: function (value) {
            this.parcours.jour=value;
            $rootScope.$broadcast('UpdateJour');
        },
        GetHeure: function () {
            return this.parcours.heure;            
        },
        SetHeure: function (value) {
        	comp=value.split(":");
	    	if(comp[0]<10){
			    comp[0]='0'+comp[0];
			} 
		    if(comp[1]<10){
		        comp[1]='0'+comp[1];
		    } 
            this.parcours.heure=comp[0]+":"+comp[1];
            
            $rootScope.$broadcast('UpdateHeure');
        },
        InitDate:function(){	          
			  var today = new Date();
			  var dd = today.getDate();
			  var mm = today.getMonth()+1;
			  var yyyy = today.getFullYear();
			  this.SetJour(dd+"-"+mm+"-"+yyyy);
			  minute = today.getMinutes();
			  hour = today.getHours();
			  /*
if(hour<10){
			        hour='0'+hour;
			    } 
			    if(minute<10){
			        minute='0'+minute;
			    } 
*/
			  this.SetHeure(hour+":"+minute);
			  console.log("---> "+hour+":"+minute);
		}
    }
}])


.factory('Infos', ['localStorageService','$rootScope', function(localStorageService,$rootScope) {
    return {
  		information: {},
  		GetAll: function () {
        	if(localStorageService.get('infos profil')!=null){
	        	this.information=angular.fromJson(localStorageService.get('infos profil'));
        	}
            return this.information;
        },
        GetAllByType: function (type) {
        	if(localStorageService.get('infos profil')!=null){
	        	this.information=angular.fromJson(localStorageService.get('infos profil'));
        	}
        	temp=[];
        	angular.forEach(this.information.favoris, function(value, key) {
        	   	if(value["type"]==type){
		        	temp.push(value);      			        	
	        	}	        	
	        })
            return temp;
        },
  		SetInfo:function(key,value){
        	this.GetAll();
	        this.information[key]=value;
			this.Save();
        },
        AddFavorite:function(type,stop_id,name,location,value){
	        this.GetAll();
	        if(this.information.favoris==null){
		        this.information.favoris=[];
	        }
	        var flag=true;	  
	            
	        angular.forEach(this.information.favoris, function(value, key) {
	        //alert(id+" "+value["id"]);  
	        	if(value["id_item"]==stop_id){
	        	//alert(id+" existe deja");
		        	flag=false;		        	        	
	        	}	        	
	        })
	        if(flag==true){
		        this.information.favoris.push({"type":type,"id_item":stop_id,"name":name,"location":location});
				this.Save();
				$rootScope.$broadcast('addFav');
	        }	       
        },
        AddFavoriteItineraires:function(depart,arrivee){
	        this.GetAll();
	        if(this.information.favoris==null){
		        this.information.favoris=[];
	        }
	        var flag=true;	  
	            
	        angular.forEach(this.information.favoris, function(value, key) {
	        	if(value["type"]=="itineraire" && value["depart"]==depart && value["arrivee"]==arrivee){
		        	flag=false;		        	        	
	        	}	        	
	        })
	        if(flag==true){
		        this.information.favoris.push({"type":"itineraire","depart":depart,"arrivee":arrivee});
				this.Save();
				$rootScope.$broadcast('AddFavoriteItineraires');
	        }	       
        },
        AddFavoriteHoraires:function(a,l,h,remote){
	        this.GetAll();
	        if(this.information.favoris==null){
		        this.information.favoris=[];
	        }
	        var flag=true;	  
	            
	        angular.forEach(this.information.favoris, function(value, key) {
	        	if(value["type"]=="horaire" && value["arret"]==a && value["ligne"]==l && value["direction"]==h){
		        	flag=false;		        	        	
	        	}	        	
	        })
	        if(flag==true){
		        this.information.favoris.push({"type":"horaire","arret":a,"ligne":l,"direction":h,"remote":remote});
				this.Save();
				$rootScope.$broadcast('AddFavoriteHoraires');
	        }	       
        },

        DeleteFavoriteHistorique:function(depart,arrivee){
        	this.GetAll();
        	if(this.information.favoris==null){
		       return;
	        }
			var flag=true;
			var index;
        	angular.forEach(this.information.favoris, function(value, key) {
        	   	if(value["type"]=="itineraire"){
	        	   	if(value["depart"]==depart &&  value["arrivee"]==arrivee){
		        	   	index=key;
			        	flag=false; 
	        	   	}		        	     			        	
	        	}
	        	
	        })
	        if(flag==false){
		        this.information.favoris.splice(index,1);
	        }
	        this.Save();
        },
        
         DeleteFavoriteHoraires:function(a,l,h){
        	this.GetAll();
        	if(this.information.favoris==null){
		       return;
	        }
			var flag=true;
			var index;
        	angular.forEach(this.information.favoris, function(value, key) {
        	   	if(value["type"]=="horaire"){
	        	   	if(value["arret"]==a &&  value["ligne"]==l && value["direction"]==h){
		        	   	index=key;
			        	flag=false; 
	        	   	}		        	     			        	
	        	}
	        	
	        })
	        if(flag==false){
		        this.information.favoris.splice(index,1);
	        }
	        this.Save();
        },

        DeleteFavorite:function(k,v){
        	this.GetAll();
        	if(this.information.favoris==null){
		       return;
	        }
			var flag=true;
			var index;
        	angular.forEach(this.information.favoris, function(value, key) {
        	   	if(value[k]==v){
		        	index=key;
		        	flag=false;      			        	
	        	}
	        	
	        })
	        if(flag==false){
		        this.information.favoris.splice(index,1);
	        }
	        this.Save();
        },
        Save:function(){
	        localStorageService.set('infos profil',angular.toJson(this.information));
        },
        Clear:function(){
	        localStorageService.clearAll();
        }

  }
}])


.directive('testdir', function(){
  return {
    require: '?ngModel',
    link: function (scope, elem, attrs, ngModel) {
    	//alert(elem);
      $(elem).DateTimePicker(new Date());
      $(elem).css("position","relative");
      $(elem).css("top","200px");
      if (!ngModel) return;
      ngModel.$render = function () {
      	 $(elem).DateTimePicker();
      };
      elem.on('change', function () {
        scope.$apply(function () {
          ngModel.$setViewValue($(elem).val());
        });
      });
    }
  }
})



.directive('stepper', function(){
  return    {
    restrict:'E',
    scope:{
      min: '=',
      max:'=',
      value:'=',
      step:'=',
      unit:'@',
      onSelected:'&'
    },    
    template: '<div class="containerStep">'+
				  '<button ng-click="value = value + step" ng-disabled="value >= max" class="step"><i class="icon ion-ios7-plus"></i></button>' + 
				  '<p></p>'+
				  '</div>'+
				  '<div class="containerValue">'+
				  '<span>{{value | addZero}} {{unit}}</span>' +
				  '</div>'+
				  '<div class="containerStep">'+
				  '<p class="low"></p>'+
				  '<button ng-click="value = value - step" ng-disabled="value <= min" class="step"><i class="icon ion-ios7-minus"></i></button>' + 			   
				'</div>',
	link: function (scope, elem, attrs) {	   	   
	  scope.$watch('value', function(oldVal, newVal) {
	     if(newVal) {
	       //scope.onSelected();
	     }
	  })	
	}
  }	
})
  
.directive('ball', function () {
    return {
        restrict:'E',
        link:function (scope, element, attrs) {
            element.addClass(attrs.cls);
            scope.$watch(attrs.color, function (color) {
                element.css('background-color', "#"+color);
            });
        }
    };
})

.directive('itineraire', function() {
    return { 
      transclude: true,
      template: '<div class="row">'+
				'<div class="col">'+
				/* '<div class="infoDirect"><strong>{{myLabel}} corr.</strong> - départ: <strong>{{myDepart}}</strong> - durée: <strong>{{myDuree}}</strong></div>'+ */
				'<div class="infoDirect"><strong class="depart"><i class="icon ion-ios7-flag placeholder-icon"></i>{{myDepart}}</strong><strong class="duree">env {{myDuree}}mn</strong><strong class="arrivee"> <i class="icon ion-ios7-flag-outline placeholder-icon"></i>{{myArrivee}}</strong></div>'+
				'</div>'+
				'</div>'+
				'<div class="row rowconteneurCercle">'+
      			'<div class="col conteneurCercle" ng-transclude>'+
				'</div>'+
				'</div>',
      restrict: 'E',
      scope: {
      	myLabel: '@myLabel',
      	myDepart: '@myDepart',
      	myArrivee: '@myArrivee',
      	myDuree: '@myDuree',
      },
      link: function (scope, elem, attrs) {
        	if(scope.myLabel=="0"){
	        	scope.myLabel="direct";
        	}else{
	        	scope.myLabel=scope.myLabel+" corr.";
        	}
      }
    }
})


.directive('station', function() {
    return { 
      transclude: true,
      template: '<div class="cercle {{myClass}}-border">'+
					'<div class="interieur {{myClass}}"></div>'+
				'</div>'+
				'<div class="lien">'+
					'<div class="interieur {{myClass}}">'+
						'<label>{{myLigne}}</label>'+
					'</div>'+
				'</div>',
      restrict: 'E',
      scope: {
        myClass: '@myClass',
        myLigne: '@myLigne'
      },
      link: function (scope, elem, attrs) {
        
      }
    }
})

.directive('correspondance', function() {
    return { 
      transclude: true,
      template: '<div class="cercle {{myArrivee}}-border">'+
					'<div class="interieur {{myDepart}}"></div>'+
				'</div>'+
				'<div class="lien">'+
					'<div class="interieur {{myDepart}}">'+
						'<label>{{myLigne}}</label>'+
					'</div>'+
				'</div>',
      restrict: 'E',
      scope: {
        myDepart: '@myDepart',
        myArrivee: '@myArrivee',
        myLigne: '@myLigne'
      },
      link: function (scope, elem, attrs) {
        
      }
    }
})

.directive('simplestation', function() {
    return { 
      transclude: true,
      template: '<div class="cercle {{myClass}}-border">'+
					'<div class="interieur {{myClass}}"></div>'+
				'</div>',
      restrict: 'E',
      scope: {
        myClass: '@myClass'
      },
      link: function (scope, elem, attrs) {
        
      }
    }
})

.directive('correspondancedetails', function() {
    return { 
      transclude: true,
      template: '<div class="cercle no-float {{myArrivee}}-border">'+
					'<div class="interieur {{myDepart}}"></div>'+
				'</div>'+
				'<div class="lienvertical">'+
					'<div class="interieur {{myDepart}}">'+
					'<label class="{{myDepart}}">{{myLigne}}</label>'+
					'</div>'+
				'</div>',
      restrict: 'E',
      scope: {
        myDepart: '@myDepart',
        myArrivee: '@myArrivee',
        myLigne: '@myLigne'
      },
      link: function (scope, elem, attrs) {
        
      }
    }
})


.directive('simplestationdetails', function() {
    return { 
      transclude: true,
      template: '<div class="cercle no-float {{myClass}}-border">'+
					'<div class="interieur {{myClass}}"></div>'+
				'</div>',
      restrict: 'E',
      scope: {
        myClass: '@myClass'
      },
      link: function (scope, elem, attrs) {
        
      }
    }
})



.controller('time', function($scope,Itineraires) {
		$scope.model={};
		var date = new Date();
		$scope.minute = date.getMinutes();
		$scope.hour = date.getHours();
		$scope.model.heure = {
		      min: 0,
		      max: 23,
		      value: $scope.hour,
		      unit:"h",
		      step:1
		    };
		$scope.model.minute = {
		      min: 0,
		      max: 59,
		      value: $scope.minute,
		      unit:"m",
		      step:5
		    };
		 
		$scope.$watch('model.minute.value', function(oldVal, newVal) {
	     if(newVal) {
	     // Itineraires.SetHeure($filter('addZero')($scope.model.heure.value)+":"+$filter('addZero')($scope.model.minute.value));
	      Itineraires.SetHeure($scope.model.heure.value+":"+$scope.model.minute.value);
	     }
	  })
	  
	  	$scope.$watch('model.heure.value', function(oldVal, newVal) {
	     if(newVal) {
	      Itineraires.SetHeure($scope.model.heure.value+":"+$scope.model.minute.value);
	     }
	  })
		
})


.directive('arretsform', function () {
    return {
      restrict: 'E',
      templateUrl : './templates/rechercheHoraires.html',
      scope: {
      },
      controller: function($scope,$http,$ionicLoading,$ionicModal,$ionicActionSheet,ficheHoraires,Infos,localStorageService,$location,$rootScope) {      
      
      		 $ionicModal.fromTemplateUrl('config.html', function(modal) {
		        $scope.modal = modal;
		    }, {
		        // Use our scope for the scope of the modal to keep it simple
				scope: $scope,
		        // The animation we want to use for the modal entrance
		        animation: 'slide-in-up',
		               focusFirstInput: true

		    });
		    
		    $scope.tester=false;
		    $scope.openArretsModal=function(){
				 $scope.modal.show();
				 if(typeof $scope.stops === 'undefined'){
						 $scope.show("recherche des arrêts en cours");
						 $http.get('http://lemet.fr/apps/fiches.php?action=getStops').success(function(data) {
						 $scope.stops=data;
			    }).finally(function() {
			    	$scope.hide();
		        });		 
			  }
			}
			
			 $scope.stopClicked=function(index){
				 console.log(index);
				 $scope.horaires.stop=index;
				 $scope.selectArret();	
				 $scope.modal.hide();		
			}

      
 	  		$scope.findObj=function(tab,what,value){
	  		console.log(tab[0]+" "+what+" "+value)
		  		tab.filter(function (element) { 
			    	return element.id === value;
				});
	  		}
	  		
	  		$scope.go = function (path) {
	  			console.log("test");
	  			$location.path(path);
	  		};
  		
			
	  		      	
      		$scope.favoris=	ficheHoraires.GetLastFiche();
      
      		$scope.horaires=[];
      		 
			 $scope.show = function($str) {
			    $ionicLoading.show({
			      template: $str
			    });
			  };
			  $scope.hide = function(){
			    $ionicLoading.hide();
			  };

			$scope.selectArret=function(){
				console.log($scope.horaires.stop);
				$scope.horaires.data=null;
					$http.get('http://lemet.fr/apps/fiches.php?action=getLignes&stop='+$scope.horaires.stop).success(function(data) {
						$scope.horaires.ligne=null;
				 	 	$scope.horaires.lignes=data;
				    }).finally(function() {
					});
			}
			
			$scope.selectLigne=function(){
				console.log($scope.horaires.ligne);
				ligne_label=$scope.horaires.lignes.filter(function (element) { 
			    	return element.id === $scope.horaires.ligne;
				});
				$scope.horaires.ligne_label=ligne_label[0]["label"];
				$http.get('http://lemet.fr/apps/fiches.php?action=getHeadsigns&ligne='+$scope.horaires.ligne+'&stop='+$scope.horaires.stop).success(function(data) {
				 	 	$scope.horaires.headsigns=data;
				    }).finally(function() {
					});
			}
			
			$scope.selectHeadsign=function(){
				console.log($scope.horaires.headsigns);
				headsign_label=$scope.horaires.headsigns.filter(function (element) { 
			    	return element.id === $scope.horaires.headsign;
				});
				$scope.horaires.headsign_label=headsign_label[0]["label"];
				ficheHoraires.SetRemote($scope.horaires.stop,$scope.horaires.ligne,$scope.horaires.headsign);
				ficheHoraires.SetSimple($scope.horaires.stop,$scope.horaires.ligne_label,$scope.horaires.headsign_label);
				$scope.favoris=ficheHoraires.GetLastFiche();
			}			
			      		  		
		    $scope.ficheHoraire=function(){
			    $scope.show("Recherche de la fiche horaire");
			    $http.get('http://lemet.fr/apps/horaires.php'+$scope.horaires.headsign).success(function(data) {
			 	 	$scope.horaires.data=data;
			    }).finally(function() {
			    	$scope.hide();
		     });		    			      
		   }
		   
		   // ACTIONS
			$scope.saveHoraire = function() {
			   $ionicActionSheet.show({
			     buttons: [
			       { text: '<b>Sauvegarder</b>' }
			     ],
			     //destructiveText: 'Effacer',
			     titleText: 'Votre fiche horaire',
			     cancelText: 'Annuler',
			     buttonClicked: function(index) {
					 Fiche=ficheHoraires.GetLastFiche();
					 console.log(Fiche.simple.arret+' '+Fiche.simple.ligne+' '+Fiche.simple.direction+' '+Fiche.remote);
					 Infos.AddFavoriteHoraires(Fiche.simple.arret,Fiche.simple.ligne,Fiche.simple.direction,Fiche.remote);
					 $scope.horairesFavoris=ficheHoraires.GetLastFiche();
					 $rootScope.$broadcast('addFavoriteHoraires');
 					 return true;
			     }
			   });
			
			 };	
      },
      link: function (scope, element, attrs) { 
		  		scope.test=function(){
			  		alert("test");
		  		}
		  		
	      }
	  }
})


.directive('lignesform', function () {
    return {
      restrict: 'E',
      templateUrl : './templates/LignesForms.html',
      scope: {
      	
      },
      controller: function($scope,$http) {
      		$scope.horaires=[];

			$scope.$watch('horaires.ligne', function() {
			    console.log($scope.horaires.ligne);
			    console.log($scope.horaires.headsign);
			    console.log($scope.horaires.arret);
			});

      		  		
		    $scope.testEnvoiHoraire=function(){
			    //console.log($scope.horaires.line);
			    $http.get('http://lemet.fr/root/Datas/geojson/3.json').success(function(data) {
			 	 	$scope.horaires.data=data;
			    }).finally(function() {
		     });		    			      
		   }	
      },
      link: function (scope, element, attrs) { 
		  		scope.test=function(){
			  		alert("test");
		  		}
		  		
	      }
	  }
})

.controller('testHoraires',function($scope){
    
})

.directive('cycle', function () {
    return {
      restrict: 'E',
      template: '<div id="slider" class="slideshow" cycle><img src="http://malsup.github.com/images/beach1.jpg" width="200" height="200" /><img src="http://malsup.github.com/images/beach2.jpg" width="200" height="200" /><img src="http://malsup.github.com/images/beach3.jpg" width="200" height="200" /><img src="http://malsup.github.com/images/beach3.jpg" width="200" height="200" /><img src="http://malsup.github.com/images/beach3.jpg" width="200" height="200" /><img src="http://malsup.github.com/images/beach3.jpg" width="200" height="200" /><img src="http://malsup.github.com/images/beach3.jpg" width="200" height="200" /><img src="http://malsup.github.com/images/beach3.jpg" width="200" height="200" /></div>',
      scope: {
       
      },
      link: function (scope, element, attrs) {
	      	$(element).find("#slider").cycle({
	               fx: 'fade',
	               timeout: 100
	           })
	      }
	  }
})

.directive('picker', function () {
    return {
      restrict: 'E',
      template: '<input id="pick" type="test"  data-field="datetime">',
      scope: {
       
      },
      link: function (scope, element, attrs) {
	      	$(element).find("#pick").DateTimePicker();
	      }
	  }
})



.directive('myDatepicker', function ($parse) {
   return {
      restrict: "E",
      replace: true,
      transclude: false,
      compile: function (element, attrs) {
         var modelAccessor = $parse(attrs.ngModel);

         var html = "<h2>test</h2><input type='text' data-field='datetime' id='" + attrs.id + "' >" +
            "</input>";

         var newElem = $(html);
         $(element).replaceWith(newElem);

         return function (scope, element, attrs, controller) {

            var processChange = function () {
               var date =new Date();// new Date(element..DateTimePicker("getDate"));

               scope.$apply(function (scope) {
                  // Change bound variable
                  modelAccessor.assign(scope, date);
               });
            };

            element.datepicker({
               inline: true,
               onClose: processChange,
               onSelect: processChange
            });

            scope.$watch(modelAccessor, function (val) {
               var date = new Date(val);
               element.DateTimePicker();//("setDate", date);
            });

         };

      }
   };
})

.controller('AppCtrl', function($scope) {
})


.controller('AppAccueil', function($scope,$ionicActionSheet,$ionicModal) {
	// MODAL
   // ACTIONS
  $scope.show_action = function() {
   // Show the action sheet
   $ionicActionSheet.show({
     buttons: [
       { text: '<b>Sauvegarder</b>' }
     ],
     destructiveText: 'Effacer',
     titleText: 'a propos de votre recherche',
     cancelText: 'Annuler',
     buttonClicked: function(index) {
       return true;
     }
   });

 };
})

.controller('PlaylistsCtrl', function($scope) {
  $scope.playlists = [
    { title: 'Reggae', id: 1 },
    { title: 'Chill', id: 2 },
    { title: 'Dubstep', id: 3 },
    { title: 'Indie', id: 4 },
    { title: 'Rap', id: 5 },
    { title: 'Cowbell', id: 6 }
  ];
})

.controller('interCtrl',function($scope){
	
})

.controller('ModalArretsCarto',function($scope, $stateParams,$http,$ionicLoading,$ionicModal) {
	  $scope.show = function($str) {
	    $ionicLoading.show({
	      template: $str
	    });
	  };
	  $scope.hide = function(){
	    $ionicLoading.hide();
	  };
	  
	 $scope.stopClicked=function(index){
	 	console.log(index);
	 	$scope.modal.hide();
	 	//window.history.back();
	 }
	 
	 $scope.show("recherche des arrêts en cours");
		 $http.get('http://lemet.fr/apps/fiches.php?action=getStops').success(function(data) {
	 	 	$scope.stops=data;
	    }).finally(function() {
	    	$scope.hide();
     });
	
})

/*
.directive('mapLeaflet', function() {
    return {
        scope: {
            center: '@',
            zoom: '@'
        },
        restrict: 'EA',
        link: function mapLink (scope, element, attrs) {
            element.addClass('map-holder');
            scope.map = new L.Map(element[0], {
                scrollWheelZoom: false 
            });
            new L.TileLayer('http://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png', { 
                attribution: 'Map data © OpenStreetMap contributors'
            }).addTo(scope.map);
            
            scope.$watch('center + zoom', function() {
                scope.map.setView(getLatLng(scope.center), scope.zoom || 2);
            });

            attrs.$observe('noZoom', function(val) {
                var func = 'enable';
                if (val != undefined) {
                    func = 'disable';
                    scope.map.zoomControl.removeFrom(scope.map);
                } else if (!scope.map.zoomControl._map) {
                    scope.map.zoomControl.addTo(scope.map);
                }

                scope.map.doubleClickZoom[func]();
                scope.map.boxZoom[func]();
            });
            
            scope.$broadcast('mapAvailable', scope.map);
        }
    };
}).directive('latlng', function() {
    return function latlngLink (scope, element, attr) {
        var cancel = angular.noop;
        scope.$watch('getShape()', function(shape) {
            if (shape) {
                cancel();
                cancel = scope.$watch(attr.latlng, function(ll) {
                    shape.setLatLng(ll);        
                }, true);
            }
        });
    }
}).directive('marker', function() {
    return {
        scope: {},
        restrict: 'EA',
        link: function markerLink (scope, element, attr) {
            scope.marker = new L.Marker(getLatLng());
            
            scope.getShape = function() { return scope.marker; }

            scope.$on('mapAvailable', function(e, map) {
                scope.marker.addTo(map);
            });
        }
    };
}).directive('circle', function() {
    return {
        scope: {
            radius: '@',
            color: '@'
        },
        restrict: 'EA',
        link: function(scope, element, attr) {
            scope.circle = new L.CircleMarker(getLatLng());
      
            scope.getShape = function() { return scope.circle; }
            
            scope.$watch('radius', function(radius) {
                scope.circle.setRadius(radius || 10); 
            });
            
            scope.$watch('color', function(color) {
                color = color || '#0033ff';
                scope.circle.setStyle({color: color, fillColor: color}); 
            });
            
            scope.$on('mapAvailable', function(e, map) {
                scope.circle.addTo(map);
            });
        }
    }
})
*/


.controller('Cartographie',function($scope,leafletData,$ionicLoading,$stateParams,$ionicModal,$http,geolocation){

	 $scope.all=[];
	 
	 $scope.nom_arret = $stateParams.nom_arret;
	 console.log($scope.nom_arret);
	 
	 $ionicModal.fromTemplateUrl('resultats.html', function(modal) {
        $scope.modalResultats = modal;
    }, {
        // Use our scope for the scope of the modal to keep it simple
		scope: $scope,
        // The animation we want to use for the modal entrance
        animation: 'slide-in-up'
    });
		  
	 $ionicModal.fromTemplateUrl('config.html', function(modal) {
        $scope.modal = modal;
    }, {
        // Use our scope for the scope of the modal to keep it simple
		scope: $scope,
        // The animation we want to use for the modal entrance
        animation: 'slide-in-up'
    });
    
     $ionicModal.fromTemplateUrl('lignes.html', function(modal) {
        $scope.modalLignes = modal;
    }, {
        // Use our scope for the scope of the modal to keep it simple
		scope: $scope,
        // The animation we want to use for the modal entrance
        animation: 'slide-in-up'
    });

	 
	 $scope.show = function($str) {
	    $ionicLoading.show({
	      template: $str
	    });
	  };
	  $scope.hide = function(){
	    $ionicLoading.hide();
	  };
	  
	  
	   var redMarker = L.AwesomeMarkers.icon({
			    markerColor: 'red',
			     icon: 'user',
			    prefix:'fa'
			});
			  
			  var busMarker = L.AwesomeMarkers.icon({
			    icon: 'bus',
			    prefix:'fa',
			    markerColor: 'green',
			    iconColor:'white'
			  });


	  $scope.locateMe=function(){	 
	 	$scope.show("recherche en cours");
		geolocation.getLocation().then(function(data){
			 $scope.coords = {lat:data.coords.latitude, long:data.coords.longitude};
			 //$scope.updateCenter($scope.coords.lat,$scope.coords.long,16);
			  		 	
	 	if(typeof $scope.geo==='undefined'){
		 	 	// pas d arrets precedement trouvés
	 	 	}else{
		 	 	$scope.geo.clearLayers();
	 	 	}
	 	 		 	 	
	 	$http.get('http://lemet.fr/apps/fiches.php?action=getStopsByLatLng&lat='+$scope.coords.lat+'&lng='+$scope.coords.long).success(function(data) {
	 	 	$scope.StopsFound=data;
	 	 	// vide le tableau pour repartir a zero
	 	 	$scope.all=[];
	 	 	if(typeof $scope.arrets==='undefined'){
		 	 	// pas d arrets precedement trouvés
	 	 	}else{
		 	 	$scope.arrets.clearLayers();
	 	 	}
	 	 	
	 	 	
			//L.marker([51.941196,4.512291]).addTo(map);
	 	 	var mark=new L.Marker([$scope.coords.lat,$scope.coords.long], {icon: redMarker});
	 	 	$scope.all.push(mark);
	 	 	mark.bindLabel("Vous êtes ici!",{ direction: 'up',noHide:true});
	 	 	for(i=0;i<$scope.StopsFound.length;i++){
		 	 	temp=$scope.StopsFound[i];
		 	 	console.log([temp.location.lat,temp.location.lng]);
		 	 	var mark=new L.Marker([temp.location.lat,temp.location.lng], {icon: busMarker});
		 	 	mark.bindLabel(temp.name+"<br>lignes : "+temp.lignes,{ direction: 'up',noHide:true});
		 	 	$scope.all.push(mark);
	 	 	}	 	 	
	 	 	$scope.arrets = L.layerGroup($scope.all);	 	 	
	 	 	$scope.arrets.addTo($scope.map);
	 	 	$scope.map.setView(new L.LatLng($scope.StopsFound[0]['location']['lat'],$scope.StopsFound[0]['location']['lng']),15);
	 	 	$scope.map.showLabel();
	    }).finally(function() {
	    	$scope.hide();
	    	$scope.modalResultats.hide();
		});
	  });
	}
	  

	  
	 $scope.stopClicked=function(index){
	 	console.log(index);	 	
	 	$scope.show();
	 	
	 	$http.get('http://lemet.fr/apps/fiches.php?action=getCompleteStop&stop='+index).success(function(data) {
	 	 	$scope.StopsFound=data;
	 	 	// vide le tableau pour repartir a zero
	 	 	$scope.all=[];
	 	 	if(typeof $scope.arrets==='undefined'){
		 	 	// pas d arrets precedement trouvés
	 	 	}else{
		 	 	$scope.arrets.clearLayers();
	 	 	}
	 	 	for(i=0;i<$scope.StopsFound.length;i++){
		 	 	console.log($scope.StopsFound[i]);
		 	 	temp=$scope.StopsFound[i];
		 	 	console.log([temp.location.lat,temp.location.lng]);
		 	 	var mark=new L.Marker([temp.location.lat,temp.location.lng], {icon: busMarker});
		 	 	mark.bindLabel(index+"<br>lignes : "+temp.lignes,{ direction: 'up',noHide:true});
		 	 	$scope.all.push(mark);
	 	 	}
	 	 	
	 	 	$scope.arrets = L.layerGroup($scope.all);
	 	 	
	 	 	$scope.arrets.addTo($scope.map);
	 	 	$scope.map.setView(new L.LatLng(temp.location.lat,temp.location.lng),17);
	 	 	$scope.map.showLabel();
	    }).finally(function() {
	    	$scope.hide();
	    	$scope.modal.hide();
		});
		
	 }
	 
	  if($scope.nom_arret!=""){
		 $scope.stopClicked($scope.nom_arret);
	 }


	 $scope.ligneClicked=function($index,name,desc,color){
	 	console.log($index,name,desc,color);
	 	$scope.show("chargement en cours");
	 	
	 	if(typeof $scope.geo==='undefined'){
		 	 	// pas d arrets precedement trouvés
	 	 	}else{
		 	 	$scope.geo.clearLayers();
	 	 	}
	 	 		 	 	
	 	$http.get('http://lemet.fr/root/Datas/geojson/'+name+'.json').success(function(data) {
			myStyle = {
		    "color": color,
		    "weight": 5,
		    "opacity": 1
			};
			console.log($index,name,desc,color);
			$scope.geo=L.geoJson(data,{style: myStyle});
			$scope.geo.bindLabel(desc+" "+name,{noHide:true});
			$scope.geo.addTo($scope.map);
			//$scope.geo.bindLabel('A sweet static label!').showLabel();
			$scope.map.fitBounds($scope.geo.getBounds());
			$scope.map.showLabel();
	    }).finally(function() {
	    	$scope.hide();
        });		 
	 	
	 	$scope.modalLignes.hide();		
	 }
	 
	 
	 $scope.adresses={};
	 
	 $scope.adresseClicked=function(adresse){
	 
	 	$scope.show("chargement en cours");	 	
	 	if(typeof $scope.geo==='undefined'){
		 	 	// pas d arrets precedement trouvés
	 	 	}else{
		 	 	$scope.geo.clearLayers();
	 	 	}
	 	 		 	 	
	 	$http.get('http://lemet.fr/apps/fiches.php?action=getStopsByAddress&adr='+adresse).success(function(data) {
	 	 	$scope.StopsFound=data;
	 	 	// vide le tableau pour repartir a zero
	 	 	$scope.all=[];
	 	 	if(typeof $scope.arrets==='undefined'){
		 	 	// pas d arrets precedement trouvés
	 	 	}else{
		 	 	$scope.arrets.clearLayers();
	 	 	}
	 	 	for(i=0;i<$scope.StopsFound.length;i++){
		 	 	temp=$scope.StopsFound[i];
		 	 	console.log([temp.location.lat,temp.location.lng]);
		 	 	var mark=new L.Marker([temp.location.lat,temp.location.lng], {icon: busMarker});
		 	 	mark.bindLabel(temp.name+"<br>lignes : "+temp.lignes,{ direction: 'up',noHide:true});
		 	 	$scope.all.push(mark);
	 	 	}	 	 	
	 	 	$scope.arrets = L.layerGroup($scope.all);	 	 	
	 	 	$scope.arrets.addTo($scope.map);
	 	 	$scope.map.setView(new L.LatLng($scope.StopsFound[0]['location']['lat'],$scope.StopsFound[0]['location']['lng']),15);
	 	 	$scope.map.showLabel();
	    }).finally(function() {
	    	$scope.hide();
	    	$scope.modalResultats.hide();
		});
	}


	 $scope.rechercher=function($adresse){
	 	//$scope.adresses={};
	 	$scope.show("recherche d'adresse...");	 		 	
	 	$http.get('http://lemet.fr/apps/adresse.php?action=rechercheadresse&adresse='+$adresse).success(function(data) {
				$scope.adresses=data;
	    }).finally(function() {
	    	$scope.hide();
	    	$scope.modalResultats.show();
        });		 
	 }


	 
	 $scope.SelectedStop={};
	 
		
	$scope.openArretsModal=function(){
		 $scope.modal.show();
		 if(typeof $scope.stops === 'undefined'){
				 $scope.show("recherche des arrêts en cours");
				 $http.get('http://lemet.fr/apps/fiches.php?action=getStops').success(function(data) {
				 $scope.stops=data;
	    }).finally(function() {
	    	$scope.hide();
        });		 
	  }
	}
	
	$scope.openLignesModal=function(){
		 $scope.modalLignes.show();
		 if(typeof $scope.lignes === 'undefined'){
				 $scope.show("recherche des lignes du réseau");
				 $http.get('http://lemet.fr/apps/fiches.php?action=getSimpleLignes').success(function(data) {
				 $scope.lignes=data;
	    }).finally(function() {
	    	$scope.hide();
        });		 
	  }
	}
	
	leafletData.getMap('map1').then(function(map) {
    	$scope.map = map; 
    	// http://lemet.fr/root/Datas/geojson/5.json
    	/*
$scope.show("recherche des arrêts en cours");
		$http.get('http://lemet.fr/root/Datas/geojson/5.json').success(function(data) {
			myStyle = {
		    "color": "#ff7800",
		    "weight": 5,
		    "opacity": 1
			};
			L.geoJson(data,{style: myStyle}).addTo($scope.map);
	    }).finally(function() {
	    	$scope.hide();
        });		 
*/

    	
	});
	
	 $scope.$on('AddMarker', function(event,latlng) {
		$scope.addMarker(latlng);  	  
	 });
	 
	 
    $ionicModal.fromTemplateUrl('config.html', function(modal) {
        $scope.modal = modal;
    }, {
        // Use our scope for the scope of the modal to keep it simple
		scope: $scope,
        // The animation we want to use for the modal entrance
        animation: 'slide-in-up'
    });
    
   $scope.metz={
            lat: 49.118225,
            lng: 6.174605,
            zoom: 16
        };
        
         $scope.markers={
            main_marker: {
                lat: 49.118225,
				lng: 6.174605,
                focus: true,
                //message: "Hey, drag me if you want",
                title: "Marker",
                draggable: true,
             }
        };

    /*
$scope.options = {
		  	  center:{49.120903, 6.176647},
		      notselected: {
		        icon: 'https://maps.gstatic.com/mapfiles/ms2/micons/red-dot.png',
		      },
		      selected: {
		        icon: 'https://maps.gstatic.com/mapfiles/ms2/micons/yellow-dot.png',
		      }
		    };

		    
		  $scope.updateCenter = function(lat, lng,zoom) {
			  $scope.center = new google.maps.LatLng(lat, lng);
			  $scope.zoom=zoom;
		  };
		  
		  $scope.updateCenter(49.120903, 6.176647,16);
*/
		    /*
 angular.extend($scope, {
        metz: {
            lat: 40.095,
            lng: -3.823,
            zoom: 18
        },
        defaults: {
            scrollWheelZoom: false
        },
        markers: {
            Madrid: {
                lat: 40.095,
                lng: -3.823,
                message: "This is Madrid. But you can drag me to another position",
                focus: true,
                draggable: true
            },
            Barcelona: {
                lat: 41.38,
                lng: 2.18,
                message: "This is Barcelona. You can't drag me",
                focus: false,
                draggable: false
            }
        }
    });
*/
    /*
angular.extend($scope, {
         metz: {
            lat: 49.118225,
            lng: 6.174605,
            zoom: 16
        }, 
        markers: {
            main_marker: {
                lat: 49.118225,
				lng: 6.174605,
                focus: true,
                //message: "Hey, drag me if you want",
                title: "Marker",
                draggable: true,
             }
        }
    });
*/

})


.controller('PlaylistCtrl', function($scope, $stateParams) {
})

.controller('Profil',function($scope){
	
})

.controller('Alertes',function($scope,$stateParams,$ionicLoading,$http,$ionicModal){
		$scope.doRefresh = function() {
   			$scope.show("chargement des alertes");	 	
		 	$http.get('http://lemet.fr/apps/rss.php?action=getRSS&type=alertes').success(function(data) {
		 	 	$scope.alertes=data.item;	 	 	
		    }).finally(function() {
		    	$scope.hide();
		    	  $scope.$broadcast('scroll.refreshComplete');
			});
		};
		
		$scope.openWEB=function($url){
			navigator.app.loadUrl($url,{ openExternal: true });
		}
  	
  		$scope.show = function($str) {
	    	$ionicLoading.show({
				template: $str
			});
		};
		
		$scope.hide = function(){
	    	$ionicLoading.hide();
		};
		
		$scope.doRefresh();	
	    // MODAL
	  $ionicModal.fromTemplateUrl('config.html', function(modal) {
	    $scope.modal = modal;
	  }, {
	    animation: 'slide-in-up',
	    focusFirstInput: true
	  });	
})


.controller('horaires',function($scope,$ionicModal,Infos){
	// MODAL
	  $ionicModal.fromTemplateUrl('config.html', function(modal) {
	    $scope.modal = modal;
	  }, {
	    animation: 'slide-in-up',
	    focusFirstInput: true
	  });
	  
	 	  
	   $scope.$on('addFavoriteHoraires', function(event) {
			 $scope.horairesFavoris=Infos.GetAllByType("horaire");
		 });
  
})

.controller('PageCtrl', function($scope,$ionicLoading,$http,$ionicModal) {
	
	$scope.doRefresh = function() {
   		 $scope.show("chargement des actus");	 	
	 	$http.get('http://lemet.fr/apps/rss.php?action=getRSS&type=actus').success(function(data) {
	 	 	$scope.articles=data.item;	 	 	
	    }).finally(function() {
	    	$scope.hide();
	    	  $scope.$broadcast('scroll.refreshComplete');
		});
	};
  		
  		$scope.openWEB=function($url){
			navigator.app.loadUrl($url,{ openExternal: true });
		}
  		
  		$scope.show = function($str) {
	    $ionicLoading.show({
	      template: $str
	    });
	  };
	  $scope.hide = function(){
	    $ionicLoading.hide();
	  };
	  
		
	 		$scope.doRefresh();	
	   $scope.twitters = [
	 { date: 'Date 1', tweets: [{msg:"lorem ipsum",link:"test"},{msg:"lorem ipsum",link:"test"},{msg:"lorem ipsum",link:"test"},{msg:"lorem ipsum",link:"test"}]},
	 { date: 'Date 2', tweets: [{msg:"lorem ipsum",link:"test"},{msg:"lorem ipsum",link:"test"}] },
	 { date: 'Date 3', tweets: [{msg:"lorem ipsum",link:"test"}] },
	 { date: 'Date 4', tweets: [{msg:"lorem ipsum",link:"test"},{msg:"lorem ipsum",link:"test"}] }
  ];
  
  
  /*
$scope.twitters = [
	 { date: 'Date 1'},
	 { date: 'Date 2'}
  ];
*/  
    // MODAL
  $ionicModal.fromTemplateUrl('config.html', function(modal) {
    $scope.modal = modal;
  }, {
    animation: 'slide-in-up',
    focusFirstInput: true
  });
})

.controller('rechercheHoraires', function($scope,$rootScope,$http,$stateParams,Mode,Coordinates,Infos,localStorageService,geolocation,Itineraires,$ionicLoading) {

})

.controller('visualisation_recherchearret',function($scope,$http,$ionicLoading,Infos,localStorageService,$location){
	$scope.go = function (path) {
	  			console.log("test");
	  			$location.path(path);
	  		};
	  		
	  $scope.show = function($str) {
	    $ionicLoading.show({
	      template: $str
	    });
	  };
	  $scope.hide = function(){
	    $ionicLoading.hide();
	  };
	  
	 $scope.stopClicked=function(index){
	 	console.log(index);
	 	window.history.back();
	 }
	 $scope.show("recherche des arrêts en cours");
		 $http.get('http://lemet.fr/apps/fiches.php?action=getStops').success(function(data) {
	 	 	$scope.stops=data;
	    }).finally(function() {
	    	$scope.hide();
     });

	
})

.controller('comp', function($scope,$rootScope,$http,$stateParams,Mode,Coordinates,Infos,$location,localStorageService,geolocation,Itineraires,$ionicLoading) {
		  
		 // http://morenoh149.github.io/2014/04/14/UI-Router-params-and-ionic.html
		 // http://www.ng-newsletter.com/posts/building-2048-in-angularjs.html#game-controller
		  $scope.mode = Mode.SetMode($stateParams.mode);
		 // alert($scope.mode);

		 
		 $scope.show = function() {
		    $ionicLoading.show({
		      template: 'Recherche en cours...'
		    });
		  };
		  $scope.hide = function(){
		    $ionicLoading.hide();
		  };
		  
		  $scope.go = function ( path ) {
			  $location.path( path );
			};

		  
		  $scope.options = {
		  	  center:{},
		      notselected: {
		        icon: 'https://maps.gstatic.com/mapfiles/ms2/micons/red-dot.png',
		      },
		      selected: {
		        icon: 'https://maps.gstatic.com/mapfiles/ms2/micons/yellow-dot.png',
		      }
		    };

		    
		  $scope.updateCenter = function(lat, lng,zoom) {
			  $scope.center = new google.maps.LatLng(lat, lng);
			  $scope.zoom=zoom;
		  };
		  
		  $scope.updateCenter(49.120903, 6.176647,16);

		  
		 
		  $scope.getStopOpts = function(resultat) {
		     return angular.extend(
		       { title: resultat.name },
		       resultat.selected ? $scope.options.selected :
		          $scope.options.notselected
		      );
		    };
		    
	     $scope.selectStop = function(resultat) {
	      if ($scope.resultat) {
	        $scope.resultat.selected = false;
	      }
	      $scope.resultat = resultat;
	      $scope.resultat.selected = true;
		  var id=$scope.resultat.id;
	      //$scope.$broadcast('gmMarkersUpdate', 'resultats');
	    };
	    
	    $scope.parcours=Itineraires.GetParcours();
	    
	     $scope.stopRevealCarto=function($nom){
		     console.log($nom);
		      $scope.go('/app/carto/'+$nom);
	     }
		
	    $scope.selectedIndex = 0;
	    $scope.choiceIndex=0;
		$scope.stopClicked = function ($index) {
		    console.log($index);
		    $scope.selectedIndex = $index;
		    Itineraires.SetSelect($scope.mode,Itineraires.GetStopsById($scope.mode,$index));
		    window.history.back();
		  }
		  
		 $scope.stopReveal = function ($index) {
		    console.log($index);
		    if($scope.choiceIndex!=$index){
			    $scope.resultats[$scope.choiceIndex].selected = false;
		    }
			$scope.resultats[$index].selected = true;
		   // $scope.$broadcast('gmMarkersUpdate', 'resultats');
		   // $scope.updateCenter($scope.resultats[$index].location.lat,$scope.resultats[$index].location.lng,18);
		    $scope.choiceIndex = $index;		    
		  }
		  
		
		 $scope.located=false;
		 
		 $scope.$on('locateMe', function(event) {
			  		$scope.locateMe();  	  
		    });
		     
		 $scope.locateMe=function(){
		 	 $scope.show();
			 geolocation.getLocation().then(function(data){
			  	$scope.coords = {lat:data.coords.latitude, long:data.coords.longitude};
			  	$scope.updateCenter($scope.coords.lat,$scope.coords.long,16);
			  	//alert($scope.coords.lat+"  "+$scope.coords.long);
			   	$http.get('http://lemet.fr/apps/adresse.php?action=get_location&lat=' + $scope.coords.lat+"&lng="+$scope.coords.long).success(function(data) {
			   		 Itineraires.SetAdresse($scope.mode,data.adresse);
				 	 $scope.resultats = data.res;
				 	 angular.forEach(data.res, function(value, key) {
			        	   	if(value["select"]=="on"){
					        	 $scope.updateCenter(value.location.lat,value.location.lng,16);	
				        	}			        	
				        })
				       $scope.located=true; 
				       Itineraires.SetStops($scope.mode,data.res);
				       $scope.$broadcast('gmMarkersUpdate', 'resultats');
				    }).finally(function() {
						$scope.hide();
			     });
			  });
		   }
		 
		 $scope.addFavorite=function($index){
		 	 $stop=$scope.resultats[$index];
		 	 Infos.AddFavorite("arret",$stop.stop_id,$stop.name,$stop.location,$stop.name);
		 }
		 
		 
		  $scope.$on('completeSelected', function(e,recup) {
			console.log(recup);
			//console.log($scope.adresses.originalObject.value);
			$scope.chercher(recup);
		  });
		  
		 		    	     
		 $scope.chercher=function(dest){
		 	 $scope.show();
		 	 console.log(dest);
		 	 //alert($scope.adresses.originalObject.value);
		 	 if(dest!=undefined){
			 	 adr=dest;
		 	 }else{
			 	 adr=$scope.adresses.originalObject.value;
		 	 }
		 	 Itineraires.SetAdresse($scope.mode,adr);
			 $http.get('http://lemet.fr/apps/adresse.php?action=get_address&address=' + adr).success(function(data) {
			 	 $scope.resultats = data;
			 	 angular.forEach(data, function(value, key) {
		        	   	if(value["select"]=="on"){
				        	 $scope.updateCenter(value.location.lat,value.location.lng,16);	
			        	}			        	
			        })
			       Itineraires.SetStops($scope.mode,data);
			      // $scope.$broadcast('gmMarkersUpdate', 'resultats');
			    }).finally(function() {
					$scope.hide();
		     });		    
		}
})

.controller('TestSearch', function($scope,$http,$timeout,$location,$stateParams,Screen,Coordinates,Itineraires,Infos,Trajet,localStorageService,$ionicSlideBoxDelegate,$ionicLoading,$ionicActionSheet,$ionicModal,leafletData) {
  
  Itineraires.InitDate();
  
  $scope.show = function() {
    $ionicLoading.show({
      template: 'Recherche en cours...'
    });
  };
  
  $scope.hide = function(){
    $ionicLoading.hide();
  };  
  
  $scope.go = function ( path ) {
	$location.path( path );
  };
	
  $scope.checkDuree=function(item){
	  return (item.resume.data.duree!=0  && typeof item.resume.data.arrivee==='undefined');
  }	
  
  $scope.calculer_duree=function(dep,arr){
	  return (dep+" "+arr);
  }	
  
  $scope.checkCorrespondance=function(item){
	  return (item.correspondances!=0);
  }
  
  $scope.recordTrajet=function(tr){
	  Trajet.SetTrajet(tr);
	  $scope.go('/app/trajet');
  }
  
  
  $scope.test = "Rechercher votre itinéraire";
  $scope.nbResultats=3;
  
  $scope.master={};
  $scope.master.movies = Coordinates.GetAll();
  $scope.master.store=Infos.GetAll();
  $scope.master.dep=Itineraires.GetSelect("depart");//"ROTONDE";
  $scope.master.arr=Itineraires.GetSelect("arrivee");
  $scope.master.jour=Itineraires.GetJour();
  $scope.master.heure=Itineraires.GetHeure();
  $scope.master.last="POUET";
  $scope.master.alternatifs={};
  
  $scope.InverseStops=function(){
	  $scope.master.dep_old=Itineraires.GetSelect("arrivee");//"ROTONDE";
	  $scope.master.arr_old=Itineraires.GetSelect("depart");
	  
	  Itineraires.SetSelect("depart",$scope.master.dep_old);
	  Itineraires.SetSelect("arrivee",$scope.master.arr_old);  
  }
  
  $scope.master.items=Itineraires.GetTrajets();
  $scope.$on('UpdateItineraire', function(event) {
	  	$scope.master.dep=Itineraires.GetSelect("depart");//"ROTONDE";
	  	$scope.master.arr=Itineraires.GetSelect("arrivee");	  	  
    });
    
   $scope.$on('UpdateJour', function(event) {
	  	$scope.parcours=Itineraires.GetParcours();
	  	$scope.master.jour=Itineraires.GetJour();
	  	$scope.master.heure=Itineraires.GetHeure();  	  
	});
	
   $scope.$on('UpdateHeure', function(event) {
	  	$scope.parcours=Itineraires.GetParcours();
	  	$scope.master.jour=Itineraires.GetJour();
	  	$scope.master.heure=Itineraires.GetHeure();	  	  
	});    
    
   	$scope.SetAsAlternatifDepart=function($index){
		 	 //alert($scope.master.alternatifs.trajets[$index]["depart"]);
			 Itineraires.SetSelect("depart",$scope.master.alternatifs.trajets[$index]["depart"]);
		 }
		  
  $scope.parcours=Itineraires.GetParcours();
  $scope.test_action = function() {  		
  	  $scope.show();
  	  $scope.nbResultats=3;
	  $scope.url="http://lemet.fr/apps/test.php?arret_depart="+$scope.master.dep+"&arret_arrivee="+$scope.master.arr+"&jour="+$scope.master.jour+"&heure_depart="+$scope.master.heure;
		   $http.get($scope.url)
		     .success(function(newItems) {
		     	 $scope.nbResultats=3;
		       //	$scope.master.items =newItems;	
		       if(newItems.alternatif==true){
			       Itineraires.SetTrajets({});
			       //alert(newItems.trajets);
			       $scope.master.alternatifs =newItems;
		       }else{
			       	Itineraires.SetTrajets(newItems);
			       	$scope.master.alternatifs ={};
			       	$scope.master.items =Itineraires.GetTrajets();
		       }			         
		     })
		     .finally(function() {
				 $scope.hide();				 
				 $scope.master.items =Itineraires.GetTrajets();
			 });
  };
  
  
  $scope.GetJours=function(daysToAdd){
    }
  
  $scope.jours=$scope.GetJours(10);
  
  // MODAL
  $scope.OpenDate=function(){
	  $ionicModal.fromTemplateUrl('date.html', function(ModalDate) {
	    $scope.ModalDate = ModalDate;
	    $scope.ModalDate.show();
	  }, {
	    animation: 'slide-in-up',
	    //focusFirstInput: true
	  });
  }
  
  	
	
	
  
  	// gestionnaire visualisation arret 
  	 $scope.metz={
            lat: 49.118225,
            lng: 6.174605,
            zoom: 16
        };
        
     $scope.markers={
        main_marker: {
            lat: 49.118225,
			lng: 6.174605,
            focus: true,
            //message: "Hey, drag me if you want",
            title: "Marker",
            draggable: true,
         }
    };
   // recupere l arret ou les arrets
   $scope.all=[];
   $scope.ShowStop=function(index){
   		
   		leafletData.getMap('map1').then(function(map) {
	   		$scope.map = map; 
	   	});
	 	console.log(index);	
	 	//$scope.all=[]; 	
	 	$scope.show();
	 	$scope.OpenMap();
	 	$http.get('http://lemet.fr/apps/fiches.php?action=getCompleteStop&stop='+index).success(function(data) {
	 	 	$scope.StopsFound=data;
	 	 	console.table($scope.StopsFound);
	 	 	// vide le tableau pour repartir a zero
	 	 	//$scope.all=[];
	 	 	if(typeof $scope.arrets==='undefined'){
		 	 	// pas d arrets precedement trouvés
	 	 	}else{
		 	 	//$scope.arrets.clearLayers();
	 	 	}
	 	 	for(i=0;i<$scope.StopsFound.length;i++){
		 	 	console.log($scope.StopsFound[i]);
		 	 	var temp=$scope.StopsFound[i];
		 	 	//console.log([temp.location.lat,temp.location.lng]);
		 	 	var mark=new L.Marker([temp.location.lat,temp.location.lng]);
		 	 	mark.bindLabel(index+"<br>lignes : "+temp.lignes,{ direction: 'up',noHide:true});
		 	 	$scope.all.push(mark);
		 	 	//mark.addTo($scope.map);
	 	 	}
	 	 	console.log("temp : " +temp)
	 	 	
	 	 	$scope.arrets = L.layerGroup($scope.all);
	 	 	
	 	 	$scope.arrets.addTo($scope.map);
	 	 	$scope.map.setView(new L.LatLng(temp.location.lat,temp.location.lng),17);
	 	 	$scope.map.showLabel();
	    }).finally(function() {
	    	$scope.hide();
		});
		}

  
   // MODAL MAP
  $scope.OpenMap=function(){
	  $ionicModal.fromTemplateUrl('map.html', function(modalmap) {
	    $scope.modalmap = modalmap;
	    $scope.modalmap.show();
	  }, {
	  	scope: $scope,
	    animation: 'slide-in-up'
	  });
  }

  

  
  // MODAL
  $ionicModal.fromTemplateUrl('config.html', function(modal) {
    $scope.modal = modal;
  }, {
    animation: 'slide-in-up',
    focusFirstInput: true
  });
  
    
  // ACTIONS
  $scope.show_action = function() {
   $ionicActionSheet.show({
     buttons: [
       { text: '<b>Sauvegarder</b>' }
     ],
     //destructiveText: 'Effacer',
     titleText: 'a propos de votre recherche',
     cancelText: 'Annuler',
     buttonClicked: function(index) {
		trajet=Itineraires.GetParcours();
		if(trajet.depart.select!="" && trajet.arrivee.select!=""){
			Infos.AddFavoriteItineraires(trajet.depart.select,trajet.arrivee.select);
		}     	
       return true;
     }
   });

 };
})

.controller('visualisation_trajet',function($scope,Trajet){
	$scope.trajet=Trajet.GetTrajet();
})

.controller('visualisation_showFiche',function($scope,ficheHoraires,$location,$stateParams,Infos,$http,$ionicLoading){
	 $scope.show = function() {
		    $ionicLoading.show({
		      template: 'Chargement de la fiche...'
		    });
		  };
     $scope.hide = function(){
	    $ionicLoading.hide();
	  };

	index=$stateParams.index;
	console.log("res : "+index);
	$scope.horaires={};
	$scope.index=index;
	$scope.horairesFavoris=Infos.GetAllByType("horaire");
  	$scope.selected=$scope.horairesFavoris[$scope.index];
  	console.log($scope.selected.remote);
    $scope.show();
    $http.get('http://lemet.fr/apps/horaires.php'+$scope.selected.remote.direction).success(function(data) {
 	 	$scope.horaires.data=data;
    }).finally(function() {
    	$scope.hide();
	});		    			      
		   
})


.controller('ModalMap',function($scope,$http,$stateParams,Screen){
	$scope.h=Screen.GetHeight();
	$scope.w=Screen.GetWidth();
	
	 $scope.options = {
		  	  center:{},
		      notselected: {
		        icon: 'https://maps.gstatic.com/mapfiles/ms2/micons/red-dot.png',
		      },
		      selected: {
		        icon: 'https://maps.gstatic.com/mapfiles/ms2/micons/yellow-dot.png',
		      }
		    };

		    
		  $scope.updateCenter = function(lat, lng,zoom) {
			  $scope.center = new google.maps.LatLng(lat, lng);
			  $scope.zoom=zoom;
		  };
		  
		  $scope.updateCenter(49.120903, 6.176647,16);
	
})

.controller('Contact', function($scope) {
})


.controller('ModalDate', function($scope,$http,$stateParams,Jours,Itineraires,Infos,localStorageService,Mode,geolocation,Itineraires) {
		$scope.jours=Jours.GetJours(4);
		$scope.slideHasChanged=function($index){
			console.log($scope.jours[$index]["data"]);
			Itineraires.SetJour($scope.jours[$index]["data"]);
		}
		$scope.upd=function(horaire){
			alert(horaire);
		}
		/*
$scope.$watch(function() {
		  return $scope.name;
		}, function(newValue, oldValue) {
		  console.log("change detected: " + newValue)
		});
*/
})
		
.controller('ModalFavoris', function($scope,$http,$stateParams,Coordinates,Infos,localStorageService,Mode,geolocation,Itineraires,$ionicLoading) {
		$scope.mode = Mode.GetMode();
  		$scope.arrets=Infos.GetAllByType("arret");
  		$scope.stopClicked = function ($index) {
		    console.log($index);
		    $scope.selectedIndex = $index;
		    Itineraires.SetSelect($scope.mode,$scope.arrets[$index]["name"]);
		    $scope.modal.hide();
		    window.history.back();
		  }
		$scope.deleteFavori=function($index){
			Infos.DeleteFavorite("id_item",$scope.arrets[$index]["id_item"]);
			$scope.arrets=Infos.GetAllByType("arret");
		};
		 $scope.$on('addFav', function(event) {
			 $scope.arrets=Infos.GetAllByType("arret");
		 });
})

.controller('ModalHoraireFavoris', function($scope,$http,$stateParams,Coordinates,Infos,localStorageService,ficheHoraires,Mode,$location,$ionicLoading) {
  		$scope.horairesFavoris=Infos.GetAllByType("horaire");
  		$scope.go = function (path) {
	  		$location.path(path);
	  	};
  		
  		$scope.showHoraire = function (index) {
		    console.log(index);		    
			$scope.selectedIndex = index;
			$scope.go('/app/fiches/'+index);
			$scope.modal.hide();
		  }
		$scope.deleteFicheFavori=function($index){
			 Infos.DeleteFavoriteHoraires($scope.horairesFavoris[$index]["arret"],$scope.horairesFavoris[$index]["ligne"],$scope.horairesFavoris[$index]["direction"]);
			 $scope.horairesFavoris=Infos.GetAllByType("horaire");
		};
		 $scope.$on('addFavoriteHoraires', function(event) {
			 $scope.horairesFavoris=Infos.GetAllByType("horaire");
		 });
})

.controller('ModalHistorique', function($scope,$http,$stateParams,Coordinates,Infos,localStorageService,Mode,geolocation,Itineraires,$ionicLoading) {
  		$scope.historique=Infos.GetAllByType("itineraire");
  		
   		$scope.itineraireClicked = function ($index) {		    
		    iti=$scope.historique[$index];
		    Itineraires.SetSelect("depart",iti["depart"]);
		    Itineraires.SetSelect("arrivee",iti["arrivee"]);
		    Itineraires.UpdateItineraire();
		    $scope.modal.hide();
		  }
		
		$scope.deleteFavoriHistorique=function($index){
			Infos.DeleteFavoriteHistorique($scope.historique[$index]["depart"],$scope.historique[$index]["arrivee"]);
			$scope.historique=Infos.GetAllByType("itineraire");
		};
		
		$scope.$on('AddFavoriteItineraires', function(event) {
			 $scope.historique=Infos.GetAllByType("itineraire");
		 });
});
